using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;


namespace Matopeli;

/// @author Omanimi
/// @version 26.10.2023
/// <summary>
/// 
/// </summary>
public class Matopeli : PhysicsGame
{

    private static readonly string[] kentta ={
        "---------------",
        "-             -",
        "-             -",
        "-          o  -",
        "-             -",
        "-             -",
        "-   km        -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "---------------",
    };
    private int seinaleveys= 600 / kentta.Length;
    private int seinakorkeus = 600 / kentta.Length;

    private static readonly Image seinakuva = LoadImage("seina.png");
    private static readonly Image matopaakuva = LoadImage("matopaa.png");
    private readonly Image matokehokuva = LoadImage("matokeho.png");
    private readonly Image omenakuva = LoadImage("omena.png");
    private readonly Image kenttatausta = LoadImage("kenttatausta.png");
    
    
    
    public readonly IntMeter pisteet = new IntMeter(0);
    private Label pisteNaytto;

    public override void Begin()
    {
        ClearAll();
       // Background.Image = LoadImage("kenttatausta");
        //LuoTausta();
    
        AloitaUusiPeli();
    }
    public void AloitaUusiPeli()
    {
        pisteet.Value = 0;
        TileMap seinat = TileMap.FromStringArray(kentta);
        seinat.SetTileMethod('-',LuoSeina);
        seinat.SetTileMethod('m',LuoMatopaa);
        seinat.SetTileMethod('o',LuoOmena);
        //seinat.SetTileMethod('k',LuoMatokeho);

        seinat.Execute(seinaleveys, seinakorkeus);
        ArvotaanOmena(kentta);
        Matoliikkeelle();
    }
    private void LuoSeina(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject seina = new PhysicsObject(leveys, korkeus);
            seina.Position = paikka;
            seina.Image = seinakuva;
            Add(seina);
        }
    
    private void LuoOmena(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject omena = new PhysicsObject(leveys, korkeus);
        omena.Position = paikka;
        omena.Image = omenakuva;
        omena.Tag = "omena";  
        Add(omena);
    }
    
    private void LuoMatopaa(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject matopaa = new PhysicsObject(leveys, korkeus);
        matopaa.Position = paikka;
        matopaa.Image = Matopeli.matopaakuva;
        matopaa.Tag = matopaa;
        AddCollisionHandler(matopaa, "omena", delegate(IPhysicsObject matopaa, IPhysicsObject omena) { MatosyoOmenan(omena); pisteet.Value += 1; });
        Timer lahtoaika = new Timer();
        lahtoaika.Interval = 1.5;
        Add(matopaa);
        lahtoaika.Timeout += KaannyOikea(matopaa);
    }
    
    //private void LuoMatokeho(Vector paikka, double leveys, double korkeus)
    //{
      //  PhysicsObject matokeho = new PhysicsObject(leveys, korkeus);
        //matokeho.Position = paikka;
        //matokeho.Image = matokehokuva;
        //Add(matokeho);  
    //})
    private void AsetaOhjaimet()
    {
        Keyboard.Listen(Key.Up, ButtonState.Down, KaannyYlos, "Turn upwards";
        Keyboard.Listen(Key.Down, ButtonState.Down, KaannyAlas, "Turn downwards";
        Keyboard.Listen(Key.Left, ButtonState.Down, KaannaVasen, "Turn left";
        Keyboard.Listen(Key.Right, ButtonState.Down, KaannaOikea, "Turn right";
    }
    private void ArvotaanOmena(string[]t)
    {
        int x = t.GetLength(0);
        int y = t.GetLength(1);
        int ix = RandomGen.NextInt(1, x - 1);
        int iy = RandomGen.NextInt(1, y - 1);
        Vector paikka = (ix, iy);
        LuoOmena(paikka, seinaleveys, seinakorkeus);
    }
    


    private void MatosyoOmenan(IPhysicsObject omena)
    {
        
        pisteet+;
        omena.Destroy();
    }

    private void KaannyVasen(IPhysicsObject matopaa)
    {
        
    }
    
    private void KaannyOikea(IPhysicsObject matopaa)
    {
        matopaa.Push(new Vector(1000, 0));
        pelaaja1.MaxVelocity = 200;
    }
    
    private void KaannyAlas(IPhysicsObject matopaa)
    {
        
    }
    
    private void KaannyYlos(IPhysicsObject matopaa)
    {
        
    }
}
